/* $Header: x.c,v 1.2 87/07/12 21:57:50 notes Exp $ */

#include "parms.h"
#include "structs.h"
#include <varargs.h>

#ifdef	TEST
#define cleanup return
#endif	TEST

/*
 *	Print out an error message and die.
 *	Call includes a number and name of routine where it
 *	died.
 *
 *	Now supports a variable number of arguments ala printf.
 *	This may introduce some non-portability, particularly w.r.t.
 *	the hp9000s500 and similar machines with backwards stacks, etc.
 *	Hopefully that gets fixed in varargs.h.	 - Tw.
 *
 *	Ray Essick 10/23/80
 *	Modified:	Tw Cook		29 November 1985
 */

/*VARARGS2*/
x (cond, p, va_alist)
int     cond;
char   *p;
va_dcl
{
    extern int  errno;
    va_list ap;
    int     ilist[10],
            i,
            saved_errno;

    if (cond == 0)
	return;			/* didn't fail */

    saved_errno = errno;	/* save, just in case */
    fprintf (stderr, "notes - fatal error (%d): ", saved_errno);
    errno = saved_errno;
    perror ("");

    /* pick off the arguments (at most 10) */
    va_start (ap);
    for (i = 0; i < 10; i++) {
	ilist[i] = va_arg (ap, int);
    }
    va_end (ap);

    fprintf (stderr, p, ilist[0], ilist[1], ilist[2], ilist[3],
	    ilist[4], ilist[5], ilist[6],
	    ilist[7], ilist[8], ilist[9]);
    fprintf (stderr, "\n");
    fflush (stderr);

#ifdef DUMPCORE
    if (fork () == 0)
	abort ();
#endif

    cleanup (BAD);		/* back to normal */
}

#ifdef	TEST
main () {
    errno = 8;
    x (1, "foo: string <\"%s\"> int<%d>", "a string", 3);
    x (0, "oh shit");
    errno = 4;
    x (1, "no parameters here");
}
#endif	TEST
