/* $Header: /g1/users/staff/gore/exp/notes/src/RCS/parms.h,v 2.0 89/04/16 00:31:37 gore Exp $ */

/*
 * There is no longer any need to change this file during installation,
 * unless you are recompiling for a different OS or processor.
 *
 * All programs in the Notes system use the NOTESUID user's home
 * directory for LIBDIR, and read all other configurable items
 * out of the file LIBDIR/config.
 *
 * W. Underwood and TW Cook, February 1986
 */

#ifdef GMAKE
/*
 * Please define all these things in config.gmake, not here.
 */
#else /*!GMAKE*/
/*
 * Definitions dependent on the UNIX OS you are using.
 *
 * Change these definitions to reflect your Unix version.
 */

#undef	SYSV				/* System V kernel */
#define	BSD4_2				/* Berkeley 4.2BSD kernel */

#define	VFORK				/* vfork call available */

/* DEFINE ONLY ONE LOCKING STYLE !!! */
#undef	LOCKF				/* lockf() exists -- Sys V Unix */
#define	FLOCK				/* flock() exists -- BSD systems */
#undef	CREATLOCK			/* lock by file creation (slow) */

/*
 * We automatically include RFA if this is compiled for HP-UX (only
 *  system in the universe with RFA), and if CREATLOCK is defined
 *  (RFA does not support the lockf() call).
 *
 * If you set RFA without CREATLOCK, you'll corrupt your notesfiles.
 */
#ifdef hpux				/* Pre-defined by cpp on all HP-UX */
#  ifndef LOCKF
#    define RFA				/* HP-UX Remote File Access */
#    define CREATLOCK			/* just to make sure */
#    undef FLOCK			/* just to make sure */
#  endif LOCKF
#endif hpux

#ifdef hp9000s500			/* Pre-defined by cpp on the 500 */
#  define FAKE_FTIME			/* Does not have ftime() syscall */
#endif hp9000s500

  /*
   * These two defines cannot be overridden by entries in the
   * "config" file.  There is little reason to ever change these
   * defines.
   */
#  define	TMPDIR		"/tmp"
#  define	NOTESUID	"notes"		/* owner of system */
#endif /* !GMAKE */

/* ------------------------------------------------------------------------- */
/*        There should be no need to change anything below this line.        */
/*           Please use the runtime config file (LIBDIR/config).             */
/* ------------------------------------------------------------------------- */


/*
 * These are defaults which can be overridden in the "config" file,
 * which lives in the home directory of $NOTESUID.
 *
 *  There is no need to change these.  Please use the config file.
 */

#define	DFLTSPOOLDIR	"/usr/spool/notes"
#define	DFLTARCHDIR 	"/usr/spool/oldnotes"
#define	ARCHTIME	14		/* default days to archive */
#define DFLTORG		"Hunga Dunga U." /* default organization */
#define	DFLTDOMAIN	".UUCP"		 /* default internet domain */


/*
 * These define "last-resort" defaults for various Unix functions.
 * Normally, this information will come from an entry in the "config"
 * file, or from a user's environment variable if they want to
 * override the default.  The values defined here will only be used
 * if there is no corresponding entry inthe config file.
 *
 * There is no need to change these.  Please use the config file.
 * Values in the config file may be read by shell scripts, so that
 * the scripts will be generic.  Relying on these values will
 * break such scripts.
 */
#define	DFLTSHELL        "/bin/csh"		/* default shell */
#define	DFLTEDITOR       "/usr/bin/vi"		/* default editor */
#define	DFLTMAILPOSTER   "notesmail"		/* mailer to use (in ~notes) */
#define	DFLTPAGER        "/usr/bin/more"	/* pg/more default */
#define	DFLTWRITE	 "/bin/write"	        /* user-user communication */

/*
 *	Some compile-time decisions.
 */
#ifndef GMAKE

#  undef  MSGID_INDEX		/* use the message-ID index */
#  undef  HPVERSION		/* turn on HP-only features:  */
				/*    safety net in newsoutput, and */
				/*    forged approval for hp.announce */
#  define AUTOCREATE		/* auto creation newsgroups */
#  define OLDGROUP   60		/* 60 day group expiration */
#  define NUKE_OLD		/* if defined, will refuse to accept or emit */
				/* articles more than ARCHTIME days old	*/
/*#define	DUMPCORE	/* trapped internal error dumps core */

#  define	PATHALIAS	"/usr/lib/notes/notes-map"
#  define	TRANSLATE	"tr 'A-Za-z' 'N-ZA-Mn-za-m' | more"

#endif /* !GMAKE */

/*
 *	Version of the database in use. You don't want to change this.
 *	This reflects the format of the notesfile database and when
 *	the database format changes, this changes. It shouldn't
 *	change unless the database format changes.
 *	Format:		yyyymmdd
 */

#define		DBVERSION	19851211	/* current format */
#define		MSGID_INDEX_VERSION "June 12, 1985"
